extends base.pug
- load leaflet_tags
- load static

block add_head
  meta(charset='utf-8')
  link(rel='stylesheet' href='https://cdn.jsdelivr.net/gh/openlayers/openlayers.github.io@master/en/v6.14.1/css/ol.css' type='text/css')
  //script(src='https://cdn.jsdelivr.net/gh/openlayers/openlayers.github.io@master/en/v6.14.1/build/ol.js')
  title OpenLayers Ruta Local
  meta(charset='UTF-8')
  // Openlayers
  link(rel='stylesheet' href='https://openlayers.org/en/latest/css/ol.css')
  script(type='text/javascript' src='https://openlayers.org/en/latest/build/ol.js')
  script(src='https://cdn.polyfill.io/v2/polyfill.min.js?features=requestAnimationFrame,Element.prototype.classList,URL,Object.assign')
  // ol-ext
  link(rel='stylesheet' href='https://cdn.rawgit.com/Viglino/ol-ext/master/dist/ol-ext.min.css')
  script(type='text/javascript' src='https://cdn.rawgit.com/Viglino/ol-ext/master/dist/ol-ext.min.js')z
  style.
    .ol-zoombt {
    display: none !important;
    }

block title
  | Ruta Local

block content
  .grid.grid-cols-12.bg-green-100(x-data="CargarFunciones();" x-init="connect();")
    .col-span-12.text-center
      div.content-center.pt-1.pb-1
        select#zona_select(name='zona_select' @change="CenterMap(event);")
          {% for z in zonas %}
          option(value='{{ z.id }}' mapzoom="{{z.zoom}}" mapcenter="[{{z.centro.0}},{{z.centro.1}}]") {{ z.nombre }}
          {% endfor %}

    .col-span-12.z-10(style="height: 50vh;")
        #map.map(style="border: none; top: 0; left: 0; right: 0; bottom: 0; height: 100%; width: 100%;")
          #popup.ol-popup
            a#popup-closer.ol-popup-closer(href='#')
            #popup-content

    .col-span-12.text-center	
      i
        | haga click en el mapa para buscar por cercanía o selecciona un punto
    .col-span-3.content-center
      template(x-for="resultado in listresults")
        div
          //span(x-text="result.distance")
          //span(x-text="result.feature")
          .grid.grid-cols-1(class="lg:grid-cols-2")	
              div.px-2	
                  button.object-fill.w-full.z-20.my-1.m-1.py-1(class="display:inline-block bg-cover bg-orange-500 hover:bg-orange-700 text-white font-bold py-2 px-2 rounded" @click="resultdict=resultado.feature.A;buttonclickactionmap(resultado.feature);")
                          img.mx-1(x-bind:src="resultado.feature.A.tipo_oferta == 0 ? '{% static 'icons/hostal.png' %}' : '{% static 'icons/cutlery.png' %}'" style="float:left;vertical-align:middle;margin:3px 2px 2px 2px" width="20" height="20")
                          
                          i
                            span(x-text="resultado.distance")
                            | km
                          br
                          b
                              span(x-text="resultado.feature.A.nombre")
                              |


    .col-span-9.content-center
      template(x-if="resultdict")
        //div
        //  span(x-text="resultdict.nombre")
        //  span(x-text="resultdict.id")
        //  span(x-text="resultdict")
        div.mr-3.bg-white.mb-2
          div.mx-3.py-5
              div.relative
                  h1.text-center.font-medium.leading-tight.text-2xl.mt-0.text-green.p-2
                     span(x-text="resultdict.nombre")
                     //|{{result.nombre}}
              div
                  .text-center
                      span(x-text="resultdict.descripcion")

                      //{{result.descripcion}}
                  //-if result.ruta
              div.py-2 
                  a.text-center.underline(x-bind:href= "'https://api.whatsapp.com/send?phone=' + resultdict.phone + '&text=Hola! encontré su contacto en RutaLocal.cl'", target="_blank")
                    img(src="{% static 'icons/whtsp.svg' %}" style="display: block;margin-left: auto;margin-right: auto;" height=20 width=20)
                    div(class="px-2") 
                      |contactar
              div.py-2 
                  a.text-center.underline(x-bind:href="'https://www.google.com/maps/dir//'+ol.proj.toLonLat(resultdict.geometry.flatCoordinates)[1].toString()+','+ol.proj.toLonLat(resultdict.geometry.flatCoordinates)[0].toString()+'/@'+ol.proj.toLonLat(resultdict.geometry.flatCoordinates)[1].toString()+','+ol.proj.toLonLat(resultdict.geometry.flatCoordinates)[0].toString()+',13z'", target="_blank")
                    img(src="{% static 'icons/gmap.png' %}" style="display: block;margin-left: auto;margin-right: auto;" height=20 width=20)
                    div(class="px-2") 
                      |cómo llegar
  
      
  style.
    .ol-zoombt {
    display: none;
    }
  script(type='text/javascript').
    function CargarFunciones(){
      return{
      listresults: [],
      panel: null,
      resultdict: false,
      map: null,
      popup: null,
      vectorSource:null,
      xyz:null,
      vectorLayer:null,
      stylesdict : {0: "{% static 'icons/cutlery.png' %}",
                    1: "{% static 'icons/cutlery.png' %}",
                    2: "{% static 'icons/hostal.png' %}",
                    3: "{% static 'icons/hostal.png' %}",
                    4: "{% static 'icons/hostal.png' %}",
                    5: "{% static 'icons/hostal.png' %}",
                    6: "{% static 'icons/hostal.png' %}",
                    7: "{% static 'icons/hostal.png' %}",
                    8: "{% static 'icons/hostal.png' %}",
                    }, 
      zonas: [
                {% for z in zonas %}
                {
                id: {{z.id}},
                zoom: {{z.zoom}},
                centro: [{{z.centro.0}},{{z.centro.1}}],
                descripcion: '{{z.descripcion}}',
                },
                {% endfor%}
            ],
      CenterMap(zona_id) {
                //console.log("Long: " + long + " Lat: " + lat);
                //var newzona = zonas.filter(m => m.date.toDateString() ===  zona_id);
                var newzona = this.zonas.filter(z => z.id ==  zona_id.target.value)[0];
                this.map.getView().setCenter(ol.proj.transform(newzona.centro, 'EPSG:4326', 'EPSG:3857'));
                this.map.getView().setZoom(newzona.zoom);
             },

      distanceBetweenPoints(latlng1, latlng2){
              var line = new ol.geom.LineString([latlng1, latlng2]);
              //console.log('holi')
              return Math.round(line.getLength()/1000 * 100) / 100 ;
          },
      distancestoallpoints(coordinate){
        var feat = this.vectorSource.getFeatures();
        var base = coordinate;
        //console.log(coordinate);
        this.listresults= [];
        this.vectorSource.forEachFeature( (feature) => {this.listresults.push({'distance':this.distanceBetweenPoints(base,feature.A.geometry.flatCoordinates),'feature':feature});});
        this.listresults.sort(function(a,b) {return a.distance - b.distance});
        //console.log(this.listresults);
      },
      buttonclickactionmap(feature){
          //console.log(feature);
          if (feature instanceof ol.Feature) {
            this.map.getView().fit(feature.getGeometry(),
                                              {
                                    maxZoom: this.map.getView().getMaxZoom() - (this.map.getView().getMaxZoom() - this.map.getView().getMinZoom())/5,
                                    duration: 1000
                                  }
            );   
            //console.log(feature);
            this.select.getFeatures().clear()// -> removes the selected items
            this.select.getFeatures().push(feature) //-> selects the applied feature
            //this.select.getFeatures().on.events.listeners.click[0].func.call(feature, event);
            //console.log('start--');
            //this.popup.setContentHTML('holaaaaa');
            //for (pop in this.popup){
            //    console.log(pop);
            //}
            //console.log(this.popup);
            this.popup.show(feature);
            //selected = new ol.Control.SelectFeature(feature);
            }
      } ,
      triggerpanel(e){
        console.log(e);
      }
      ,
      refreshbuttonspanel(){
          this.panel = new ol.Control.Panel();
          for (r in this.listresults){
              var btnHiLite = new ol.Control.Button({ 
                  title: "click it to rotate image 90º",
                  id: 'btnHiLite',
                  trigger: triggerpanel,
                  type: ol.Control.TYPE_BUTTON
                });   
              this.panel.addControls([btnHiLite]);

          }
      }
      ,
      connect(){
        //console.log(this.stylesdict);
        //this.stylesdict = {               
                
        this.xyz= new ol.source.XYZ({url: "{{settings.TILE}}"});
        this.vectorSource= new ol.source.Vector({
        url: 
              'https://rutalocal.nestolab.cl'+
              //'http://localhost:8081'+
              '/wfs/ot/'+
              '?service=WFS&' +
              'version=2.0.0&request=GetFeature&typename=ofertaturistica&'+
              'outputFormat=application/json'
        ,
        format: new ol.format.GeoJSON(),
        });
        //console.log(this.stylesdict);

        this.vectorLayer= new ol.layer.Vector({
            source: this.vectorSource,
            displayInLayerSwitcher: false,
            style: (feature) => {
                          //console.log(this.stylesdict);
                          //console.log(feature.get("tipo_oferta"));
                          s = new ol.style.Style({
                            image: new ol.style.Icon({src: this.stylesdict[feature.get("tipo_oferta")],anchor: [0.5, 0.5]})
                            });
                          var actualZoom = this.map.getView().getZoom();
                          var MaxZoom = this.map.getView().getMaxZoom();
                          var MinZoom = this.map.getView().getMinZoom();

                          //console.log(actualZoom);
                          //console.log(MaxZoom);
                          //console.log(MinZoom);

                          s.getImage().setScale(Math.max(0.07*10**(-(MaxZoom-actualZoom)/(MaxZoom-MinZoom)),0.01))
                          //console.log(0.07*10**(-(MaxZoom-actualZoom)/(MaxZoom-MinZoom)));
                          //console.log(0.07-(10**((MaxZoom-actualZoom)/(MaxZoom-MinZoom))-1));
                          //Math.max(25-4*(10**((15 -zoomLevel)/9) -1),3)
                          //console.log(zoom);
                          return s;
                        },
                    
              });

        selectedStyle = {
              LineString: new ol.style.Style({
                  stroke: new ol.style.Stroke({
                        color: 'blue',
                        width: 8
                  })
              }),
              Polygon: new ol.style.Style({
                  stroke: new ol.style.Stroke({
                      color: 'blue',
                      width: 4
                    }),
                  fill: new ol.style.Fill({
                      color: 'rgba(0, 0, 255, 0.1)'
                  })
                  }),
              Point: new ol.style.Style({
                  image: new ol.style.RegularShape({
                      fill: new ol.style.Fill({
                          color: 'rgba(255, 255, 255, 0.5)'
                      }),
                      stroke: new ol.style.Stroke({
                          color: 'orange',
                          width: 10
                      }),
                      points: 4,
                      radius: 2,
                      angle: Math.PI / 4
                        })
                })
        };

        var selectedStyleFunction = (feature, resolution) => {

            if (feature instanceof ol.Feature){
            //var featureStyleFunction = feature.getStyleFunction();
            
            var type = feature.getGeometry().getType();
            //console.log(type);
            return selectedStyle[type];
            }
        };

        // popup features
        this.select= new ol.interaction.Select({
                  hitTolerance: 6,
                  style: selectedStyleFunction,
                  multi:true,
                  condition: ol.events.condition.singleClick
                });


        // Popup associated with the select
        this.popup= new ol.Overlay.PopupFeature({
        popupClass: 'default anim',
        canFix: false,
        closeBox: true,
        select: this.select,
        showImage: false,
        template: {
        title: 
          (f) => {
            //console.log(this.stylesdict[f.get("tipo_oferta")].getSrc);
            return "<b>"+f.get('nombre')+"</b>"+"<img width='25' height='25' src='"+this.stylesdict[f.get("tipo_oferta")]+"'></img>";
          },
        attributes:{},
        },

        });
        //const container = document.getElementById('popup');
        
        
        //const attributtionscontainer = document.getElementById('attributtionscontainer');
        const container = document.getElementById('popup');
        const content = document.getElementById('popup-content');
        const closer = document.getElementById('popup-closer');

        //const popup =  new ol.Overlay({
        //  element: container,
        //  autoPan: {
        //    animation: {
        //      duration: 250,
        //    },
        //  },
        //});

        this.popup.on('select', (e) => {
          this.resultdict=e.feature.A;
          //console.log('waat');
          });// this.loadSelectedResult(e));


        // popup and distance functionality



        /**
         * Create an overlay to anchor the popup to the map.
         */
        const overlay =  new ol.Overlay({
          element: container,
          autoPan: {
            animation: {
              duration: 100,
            },
          },
        });

        /**
         * Add a click handler to hide the popup.
         * @return {boolean} Don't follow the href.
         */
        closer.onclick = function () {
          overlay.setPosition(undefined);
          closer.blur();
          return false;
        };

        var layerswitcher = new ol.control.LayerSwitcher({
          collapsed: false,
          mouseover: true,
          reordering: false,
          extent:false,
          show_progress:true,
        });

        //layerswitcher.on('toggle', (e) => {
        //  console.log('Collapse layerswitcher', e.collapsed);
        //});

        var scale = new ol.control.ScaleLine({
          minWidth: 64,
          maxWidth: 2000,
          bar: false,
          steps:4,
          text:false,
          dpi: undefined,
        });
        
        var zoomslider = new ol.control.ZoomSlider({
          duration: 500,
          className : 'ol-zoomslider',

        });
        var fullscreen = new ol.control.FullScreen({
          //duration: 200,
          //className : 'ol-zoomslider',

        });

        var mouseposition = new ol.control.MousePosition({
          //duration: 200,
          //className : 'ol-zoomslider',

        });
        var ovmap = new ol.control.OverviewMap({
          //duration: 200,
          //className : 'ol-zoomslider',

        });
        var rotate = new ol.control.Rotate({
        //  duration: 200,
        //  className : 'ol-zoomslider',

        });
        var zoom = new ol.control.Zoom({
          //zoom: 200,
          //className : 'ol-zoomslider',

        });
        var zoomextent = new ol.control.ZoomToExtent({
          //duration: 200,
          //className : 'ol-zoomslider',

        });
        var attribution = new ol.control.Attribution({
          //target: attributtionscontainer,
          collapsed:false,
          //collapsible:false,
          //duration: 200,
          //className : 'ol-zoomslider',

        });

        var geob = new ol.control.GeolocationButton({
          title:'Mi posición',
          delay:180*360,
          //target: attributtionscontainer,
          //collapsed:false,
          //collapsible:false,
          //duration: 200,
          //className : 'ol-zoomslider',

        });
        



        
        var layersen = new ol.layer.Tile({
                            title: "Actual: Sentinel-2",
                            baseLayer: true,
                            source: this.xyz,
                            });
        var layerg = new ol.layer.Tile({
                            title: "+Resolución Google",
                            baseLayer: false,
                            visible: false,
                            source: new ol.source.XYZ({url: "http://mt0.google.com/vt/lyrs=s&hl=en&x={x}&y={y}&z={z}&s=Ga"})
                            });

        var layergc = new ol.layer.Tile({
                            title: "Caminos Google",
                            baseLayer: false,
                            visible: false,
                            source: new ol.source.XYZ({url: "https://mt1.google.com/vt/lyrs=h&x={x}&y={y}&z={z}"})
                            });
        
        this.panel = new ol.Control.Panel();//{defaultControl: btnHiLite});

        
        
        
        this.map = new ol.Map({
                        target: 'map',
                        interactions: ol.interaction.defaults({ altShiftDragRotate:false, pinchRotate:false }),
                        controls: [layerswitcher,scale,zoomslider,fullscreen,geob,this.panel],
                        layers: [layersen,layerg,layergc,this.vectorLayer],
                        overlays: [overlay,this.popup],
                        view: new ol.View({
                          center: ol.proj.fromLonLat({{settings.CENTER}}),
                          zoom: {{settings.ZOOM}},
                          minZoom: 7,
                          maxZoom: 16,
                          })
                        });
        //this.map.addOverlay(this.popup);
        
        
        //this.map.addControl (new ol.control.LayerSwitcherImage());

        this.map.addInteraction(this.select);
           // Reset layer data when too much features in memory
        this.map.on('moveend', (e) => {if (this.vectorSource.getFeatures().length > 30000) {this.vectorSource.refresh();}});
        
        /**
         * Add a click handler to the map to render the popup.
         */
        this.map.on('singleclick', (evt) => {
          const coordinate = evt.coordinate;
          const hdms = ol.coordinate.toStringHDMS(ol.proj.toLonLat(coordinate));

          //content.innerHTML = '<p>Buscando cercanía:</p><code>' + hdms + '</code>';
          content.innerHTML = "<img height=25 width=25 src={% static 'icons/ask.png' %}>";
          overlay.setPosition(coordinate);
          this.distancestoallpoints(coordinate);

          //this.distancestoallpoints(coordinate);

        });
        

      
      },
      }
    };